#include <ioat94k.h>
#include "at94k_interrupts.h"
#include "at94k_utils.h"
 
typedef unsigned long int  LWORD;
typedef unsigned  int       WORD;
typedef unsigned char       BYTE;
typedef WORD              *pWORD;
 
#define RD_Z    (1 << 0)
#define WRL_Z   (1 << 1)
#define WRH_Z   (1 << 2)
#define CS0_Z   (1 << 3)
#define CS1_Z   (1 << 4)
#define HLDA_Z  (1 << 5)
#define BUSOFF  (1 << 6)
#define UNUSED  (1 << 7)

#define DATA_CHAIN    0x1
#define ADDRESS_CHAIN 0x2

void reset(void)
{
    EXTERNAL_INTS(DISABLE);
    TIMER_INTS(DISABLE);
    FPGA_INT_ALL(DISABLE);
    GLOBAL_INT(DISABLE);
}


unsigned int read_memory0(long int address)
{
  BYTE c;
  FISCR = 0;
  FISUA = ADDRESS_CHAIN; // Select the address register chain
  FISUB = (address >> 0) & 0xFF;
  FISUB = (address >> 8) & 0xFF;
  FISUB = (address >> 16)& 0XFF;
  FISUB = (RD_Z | CS0_Z);
  FISUB = (RD_Z | CS0_Z);   // Start read  (data unimportant)
  FISUB = (RD_Z | CS0_Z);   // wait        (data unimportant)
  FISUB = (RD_Z | CS0_Z);   // wait        (data unimportant)
  c = FISUC;                // Read lower byte
  return ((FISUD << 8) | c);// Read upper byte and merge
}


void write_memory1(long int address, unsigned int data)
{
  FISCR = 0;
  FISUA = DATA_CHAIN; // Select the data register chain
  FISUB = (data & 0xff);
  FISUB = (data >> 8) & 0xff;
  FISUB = (address & 0xff);
  FISUB = (address >> 8) & 0xff;
  FISUB = (address >> 16) & 0XFF;
  FISUB = (WRL_Z | WRH_Z | CS1_Z); // Control register
  FISUB = (WRL_Z | WRH_Z | CS1_Z); // Start Write (data unimportant)
  // **** Please note that you should not write until the write has been completed
  // It will take a couple of clock cycles after this instruction.
}

WORD buffer[256];
void  wait(void)
{

}
volatile    WORD  data;
void  strncpy(pWORD from, pWORD to, BYTE size)
{
    WORD i;
    for(i = 0; i < size; i++) {
      data = read_memory0((long int) &from[i]);
      buffer[i] = data;
    }
    for(i = 0; i < size; i++) {
      data  = ~buffer[i];
      write_memory1((long int) &to[i], data);
    }
}
void  main(void)
{
    reset();
    strncpy((pWORD) 40, (pWORD) 80, 10);
    while(1) {
      wait();
    }
}

